/* Copyright (c) 2012, Steffen Wittmeier, Michael Jäntsch
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * * Neither the name of the Technische Universitaet Muenchen nor the names of
 *   its contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef CAN_H_
#define CAN_H_

#include "libstm32/stm32fwlib.h"

#define CAN_ID0 (*(vu8*)0x0801FC00);
#define CAN_ID1 (*(vu8*)0x0801FC02);
#define CAN_ID_JOINT (*(vu8*)0x0801FC08);

namespace eu
{
namespace er
{
namespace fw
{
namespace ecu
{
namespace hal
{

class Can
{

public:

	Can();

	static void
	(*can_interrupt_handler)(void);

	void
	on();

	void
	off();

	s8
	send(CanTxMsg *TxMessage);

	s8
	send(u32 can_id, u8 dlc = 0, u8 d0 = 0, u8 d1 = 0, u8 d2 = 0, u8 d3 = 0,
			u8 d4 = 0, u8 d5 = 0, u8 d6 = 0, u8 d7 = 0, u8 ide = CAN_ID_STD,
			u8 rtr = CAN_RTR_DATA);

	void
	receive(CanRxMsg * RxMessage);

	void
	setCanInterruptHandler(void(*canInterruptHandler)(void));

	static void
	setReceiveBroadcast(bool receiveBroadcast);

private:

	static void
	initializeCan();

	///If one-time initialization has already been executed.
	static bool caninitialized;

	static bool receiveBroadcast;
};

}
}
}
}
}

#endif
